/**
 * @file main.c
 * @author Florian Burgener
 * @brief Exercice 2
 * @version 1.0
 * @date 2021-12-07
 * 
 * @copyright Copyright (c) 2021
 * 
 */

#include <stdbool.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>

#define LATIN_SQUARE_SIZE 4

/**
 * @brief Checks if the Latin square is normalized.
 * 
 * @param latin_square 
 * @return bool
 */
bool is_latin_square_normalized(int32_t latin_square[LATIN_SQUARE_SIZE][LATIN_SQUARE_SIZE]) {
    for (int32_t i = 0; i < LATIN_SQUARE_SIZE; i += 1) {
        if (latin_square[0][i] != i + 1 || latin_square[i][0] != i + 1) {
            return false;
        }
    }

    return true;
}

int main() {
    int32_t latin_square[LATIN_SQUARE_SIZE][LATIN_SQUARE_SIZE];

    // Initialization of the Latin square from the input data.
    for (int32_t i = 0; i < LATIN_SQUARE_SIZE; i += 1) {
        for (int32_t j = 0; j < LATIN_SQUARE_SIZE; j += 1) {
            int32_t tmp;
            scanf("%d", &tmp);
            latin_square[i][j] = tmp;
        }
    }

    bool is_normalized = is_latin_square_normalized(latin_square);
    printf("\nlatin normalisé: %s\n", (is_normalized ? "oui" : "non"));

    return EXIT_SUCCESS;
}