/**
 * @file main.c
 * @author Florian Burgener
 * @brief Exercice 3
 * @version 1.0
 * @date 2021-12-07
 * 
 * @copyright Copyright (c) 2021
 * 
 */

#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>

/**
 * @brief Count all the possibilities of dividing a sum of money into pieces of 2, 5 and 10.
 * 
 * @param remaining_money 
 * @param available_money 
 * @return int32_t 
 */
int32_t count_posibilities(int32_t remaining_money, int32_t available_money) {
    if (available_money == 1) {
        // No matter how much money is left, it is a possibility because you can have n * 1 pieces.
        return 1;
    }

    int32_t next_available_money = available_money;

    // Determines which unit of money will be used for further calculations.
    // 10 => 2
    // 2 => 1
    if (next_available_money == 10) {
        next_available_money = 2;
    } else if (next_available_money == 2) {
        next_available_money = 1;
    }

    int32_t count = 0;
    int32_t i = 0;

    // As long as the multiplication of i by the current money unit is smaller than or equal to the remaining money, continue to loop.
    while (remaining_money >= i * available_money) {
        // Calls back the function by withdrawing the right amount of money.
        count += count_posibilities(remaining_money - available_money * i, next_available_money);
        i += 1;
    }

    return count;
}

int main() {
    int32_t input;
    scanf("%d", &input);

    int32_t count = count_posibilities(input, 10);
    printf("\n%d\n", count);

    return EXIT_SUCCESS;
}