/**
 * @file main.c
 * @author Florian Burgener
 * @brief Exercice 4
 * @version 1.0
 * @date 2021-12-07
 * 
 * @copyright Copyright (c) 2021
 * 
 */

#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>

#include "stack.h"

int main() {
    int32_t tab_length = 7;
    double tab[tab_length];

    // Retrieves the input numbers.
    for (int32_t i = 0; i < tab_length; i += 1) {
        double number;
        scanf("%lf", &number);
        tab[i] = number;
    }

    // Initialization of the algorithm.
    int32_t interv[tab_length];
    interv[0] = 1;
    stack s;
    stack_init(&s, tab_length);
    stack_push(&s, 0);

    // For each number in tab.
    for (int32_t i = 0; i < tab_length; i += 1) {
        while (true) {
            int32_t top_value;
            stack_peek(s, &top_value);

            if (stack_is_empty(s) || tab[top_value] > tab[i]) {
                break;
            }

            stack_pop(&s, &top_value);
        }

        // Sets interv[i]
        if (stack_is_empty(s)) {
            interv[i] = i + 1;
        } else {
            int32_t top_value;
            stack_peek(s, &top_value);
            interv[i] = i - top_value;
        }

        stack_push(&s, i);
    }

    printf("\n");

    // Displays the interv array.
    for (int32_t i = 0; i < tab_length; i += 1) {
        printf("%d\n", interv[i]);
    }

    stack_destroy(&s);
    return EXIT_SUCCESS;
}