/**
 * @file stack.h
 * @author Florian Burgener (florian.burgener@etu.hesge.ch)
 * @brief Header de librairie stack.
 * @version 1.0
 * @date 2021-12-07
 *
 * @copyright Copyright (c) 2021
 *
 */

#ifndef STACK_H
#define STACK_H

#include <stdbool.h>

typedef struct _stack {
    int size;
    int top;
    int *data;
} stack;

void stack_init(stack *s, int size);
bool stack_is_empty(stack s);
void stack_push(stack *s, int val);
void stack_pop(stack *s, int *val);
void stack_peek(stack s, int *val);
void stack_destroy(stack *s);

#endif
