/**
 * @file main.c
 * @author Florian Burgener
 * @brief Exercice 5
 * @version 1.0
 * @date 2021-12-07
 * 
 * @copyright Copyright (c) 2021
 * 
 */

#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>

/**
 * @brief Sort the table in reverse order.
 * 
 * @param array 
 * @param array_length 
 * @param i 
 */
void reverse_array(double *array, int32_t array_length, int32_t i) {
    if (i == array_length / 2) {
        // Stops when half of the array is reached, the array is now reversed.
        return;
    }

    double tmp = array[i];
    // Swap value from right side to the left side.
    array[i] = array[array_length - 1 - i];
    // Swap value from left side to the right side.
    array[array_length - 1 - i] = tmp;

    reverse_array(array, array_length, i + 1);
}

int main() {
    int32_t array_length = 6;
    double array[array_length];

    // Retrieves the input numbers.
    for (int32_t i = 0; i < array_length; i += 1) {
        double number;
        scanf("%lf", &number);
        array[i] = number;
    }

    reverse_array(array, array_length, 0);
    printf("\n");

    // Displays the array once it has been inverted.
    for (int32_t i = 0; i < array_length; i += 1) {
        printf("%.1lf\n", array[i]);
    }

    return EXIT_SUCCESS;
}